/**
 *
 * This file is part of Porgy (https://gforge.inria.fr/projects/porgy/)
 *
 * from LaBRI, University of Bordeaux 1, Inria Bordeaux - Sud Ouest and King's College London
 *
 * Porgy is free software;  you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 *
 * Porgy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this Porgy.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef INTERACTORPORTGRAPHDELELEMENTCOMPONENT_H
#define INTERACTORPORTGRAPHDELELEMENTCOMPONENT_H

#include <tulip/GLInteractor.h>
#include <tulip/Observable.h>

#include <vector>

namespace tlp {
class MouseElementDeleter;
class Graph;
struct node;
}

class PortGraphDelElementComponent:public tlp::GLInteractorComponent, public tlp::Observable {
	typedef std::set< tlp::Observable * >::iterator ObserverIterator;

	tlp::MouseElementDeleter *tulipedelinteractor;
	std::vector<tlp::node> nodetodelete;
	bool started;

    void delPortNode(tlp::node, tlp::Graph *);
    void delEdge(tlp::Graph *, const tlp::edge);
    void treatEvent(const tlp::Event &message);
    void treatEvents(const std::vector<tlp::Event> &);

public:
	PortGraphDelElementComponent();
	virtual ~PortGraphDelElementComponent();
    void viewChanged(tlp::View *view);
	bool eventFilter(QObject *, QEvent *);
};

#endif
