#include "../../StandardInteractorPriority.h"

#include <portgraph/PorgyConstants.h>

#include <porgy/elementinformationinteractorcomponent.h>

#include <tulip/MouseInteractors.h>
#include <tulip/NodeLinkDiagramComponentInteractor.h>

using namespace tlp;

class PortNodeEditionInteractor: public tlp::NodeLinkDiagramComponentInteractor
{
public:

    PortNodeEditionInteractor(const tlp::PluginContext *):NodeLinkDiagramComponentInteractor(":/tulip/gui/icons/i_select.png","Get information on nodes/edges"){
        setConfigurationWidgetText(QString("<h3>Get information interactor</h3>")+
                                   "<b>Mouse left</b> click on an element to display its properties");
        setPriority(StandardInteractorPriority::GetInformation);
    }

    bool isCompatible(const std::string &viewName) const {
    return ((viewName==PorgyConstants::GRAPH_VIEW_NAME)||(viewName==PorgyConstants::RULE_VIEW_NAME));
    }

    void construct(){
        push_front(new ElementInformationInteractorComponent());
        push_front(new MouseNKeysNavigator());
    }


    PLUGININFORMATION("PortNodeEditionInteractor", "Jonathan Dubois", "02/10/2012", "PortGraph informtation interactor", "1.0","Porgy")
};


PLUGIN(PortNodeEditionInteractor)
