#ifndef GLMAINWIDGETZOOMANDPANANIMATION_H
#define GLMAINWIDGETZOOMANDPANANIMATION_H

#include <tulip/Animation.h>
#include <tulip/GlSceneZoomAndPan.h>

namespace tlp{
class GlMainWidget;
}

class GlSceneZoomAndPanAnimation : public tlp::Animation
{
public:
    GlSceneZoomAndPanAnimation(tlp::GlScene *glScene, const tlp::BoundingBox& newViewPort, int frameCount=1,bool optimalPath = true, double p = sqrt(1.6), QObject *parent=NULL);

    void setFrameCount(int frameCount){
        Animation::setFrameCount(frameCount);
        sceneZoomAndPan.setNbAnimationSteps(frameCount);
    }

    void frameChanged(int frame);

private:
    tlp::GlSceneZoomAndPan sceneZoomAndPan;
};


/**
 * @brief The GlMainWidgetZoomAndPanAnimation class is an extention of the GlSceneZoomAndPanAnimation class to automatically redraw the GlMainWidget at each frame.
 */
class GlMainWidgetZoomAndPanAnimation : public GlSceneZoomAndPanAnimation
{
public:
    GlMainWidgetZoomAndPanAnimation(tlp::GlMainWidget* widget, const tlp::BoundingBox& newViewPort, int frameCount=1,bool optimalPath = true, double p = sqrt(1.6), QObject *parent=NULL);
    void frameChanged(int frame);

private:
    tlp::GlMainWidget* _glWidget;
};

#endif // GLMAINWIDGETZOOMANDPANANIMATION_H
