/**
 *
 * This file is part of Porgy (https://gforge.inria.fr/projects/porgy/)
 *
 * from LaBRI, University of Bordeaux 1, Inria Bordeaux - Sud Ouest and King's College London
 *
 * Porgy is free software;  you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 *
 * Porgy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this Porgy.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef NEWTRACE_H
#define NEWTRACE_H

#include <QDialog>

namespace Ui {
    class NewTrace;
}

namespace tlp {
    class Graph;
}

class NewTrace : public QDialog
{
    Q_OBJECT    

public:
    ~NewTrace();
    static tlp::Graph* createNewTrace(tlp::Graph* parentGraph,QWidget *parent);

private:

    NewTrace(QWidget *parent, tlp::Graph *graph);
    tlp::Graph* buildNewTrace();
    void fillPortNodesForGraph(tlp::Graph* g,QSet<QString>& list);

    tlp::Graph *graph;
    Ui::NewTrace *ui;

private slots:
    void histogram_radio();
    void standard_radio();
    void fillPortNodesCombobox();

protected slots:
    void accept();

signals:
    void addNewTraceView();
    void addGraph();

};

#endif
