/**
 *
 * This file is part of Porgy (https://gforge.inria.fr/projects/porgy/)
 *
 * from LaBRI, University of Bordeaux 1, Inria Bordeaux - Sud Ouest and King's College London
 *
 * Porgy is free software;  you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 *
 * Porgy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this Porgy.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef MODELSWIDGET_H
#define MODELSWIDGET_H

#include <QWidget>

namespace Ui {
    class ModelsWidget;
}

namespace tlp{
    class Graph;
}

class ModelGraphTreeModel;
class SortFilterProxyModel;
class QModelIndex;

class ModelsWidget : public QWidget
{
    Q_OBJECT

public:
    explicit ModelsWidget(QWidget *parent = 0);
    ~ModelsWidget();
    void setGraph(tlp::Graph* graph);
    QList<tlp::Graph*> selectedModels()const;
    bool eventFilter(QObject *, QEvent *);

signals:
    void showModel(tlp::Graph*);

private slots:
    void indexDoubleClicked(const QModelIndex& index);

    void filterModels(const QString& pattern);

    void updateIconSize();

private:
    Ui::ModelsWidget *ui;
    ModelGraphTreeModel *_model;
    SortFilterProxyModel *_proxyModel;
    tlp::Graph* _graph;
};

#endif // MODELSWIDGET_H
