#ifndef STATUSBARPLUGINPROGRESS_H
#define STATUSBARPLUGINPROGRESS_H

#include <QWidget>
#include <tulip/SimplePluginProgress.h>

#include <QTime>
namespace Ui {
class StatusBarPluginProgress;
}

/**
 * @brief The StatusBarPluginProgress class is a simple plugin progress returned by the porgy perspective when the progress function is called.
 * This widget is designed to be set in the progress bar
 */
class StatusBarPluginProgress : public QWidget, public tlp::SimplePluginProgress
{
    Q_OBJECT
    Ui::StatusBarPluginProgress *_ui;
    QTime _lastUpdate;
    void checkLastUpdate();
    
public:
    explicit StatusBarPluginProgress(QWidget *parent = 0);
    ~StatusBarPluginProgress();
    void setComment(const std::string& mgs);
    void setError(const std::string& error);
    void progress_handler(int step, int max_step);
    bool isPreviewMode() const{
        return false;
    }
private slots:
    void cancelClicked();
    void stopClicked();

};

#endif // STATUSBARPLUGINPROGRESS_H
