#include "statusbarpluginprogress.h"
#include "ui_statusbarpluginprogress.h"

#include <QStyle>

StatusBarPluginProgress::StatusBarPluginProgress(QWidget *parent) :
    QWidget(parent),
    _ui(new Ui::StatusBarPluginProgress)
{
    _ui->setupUi(this);
    _ui->cancelPushButton->setIcon(QApplication::style()->standardIcon(QStyle::SP_DialogCancelButton));
    _ui->stopPushButton->setIcon(QApplication::style()->standardIcon(QStyle::SP_MediaStop));
    connect(_ui->cancelPushButton,SIGNAL(clicked()),SLOT(cancelClicked()));
    connect(_ui->stopPushButton,SIGNAL(clicked()),SLOT(stopClicked()));
}

StatusBarPluginProgress::~StatusBarPluginProgress()
{
    delete _ui;
}

void StatusBarPluginProgress::setComment(const std::string& mgs){
    _ui->label->setText("<b>" + QString::fromUtf8(mgs.c_str()) + "</b>");
    checkLastUpdate();
}

void StatusBarPluginProgress::setError(const std::string& error){
    SimplePluginProgress::setError(error);
}

void StatusBarPluginProgress::progress_handler(int step, int max_step){
    _ui->progressBar->setValue(step);
    _ui->progressBar->setMaximum(max_step);
    checkLastUpdate();
}

void StatusBarPluginProgress::checkLastUpdate() {
  if (_lastUpdate.msecsTo(QTime::currentTime()) > 1000) {
    QApplication::processEvents(QEventLoop::AllEvents,1000);
    _lastUpdate = QTime::currentTime();
  }
}
void StatusBarPluginProgress::cancelClicked() {
  cancel();
}

void StatusBarPluginProgress::stopClicked() {
  stop();
}
