/**
 *
 * This file is part of Porgy (https://gforge.inria.fr/projects/porgy/)
 *
 * from LaBRI, University of Bordeaux 1, Inria Bordeaux - Sud Ouest and King's College London
 *
 * Porgy is free software;  you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 *
 * Porgy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this Porgy.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "tracesitemmodel.h"

#include <portgraph/PorgyTlpGraphStructure.h>

using namespace tlp;
using namespace std;

TracesItemModel::TracesItemModel(QObject* parent):SubgraphsHierachyTreeModel(parent)
{
#ifdef NDEBUG
    setColumns(Columns(NameColumn));
#else
    setColumns(Columns(IdColumn | NameColumn | NodesNumberColumn));
#endif
}

void TracesItemModel::treatGraphEvent(const tlp::GraphEvent &graphEvent){
    Graph* graph = graphEvent.getGraph();
    switch(graphEvent.getType()){
    case GraphEvent::TLP_AFTER_SET_ATTRIBUTE:{
        if(graphEvent.getAttributeName() == std::string("PORGY, do not display")) {
            bool hide = true;
            graph->getAttribute("PORGY, do not display",hide);
            if(hide){
                removeGraph(graph);
            }
            return;
        }
    }
        break;
    default:
        break;
    }
    SubgraphsHierachyTreeModel::treatGraphEvent(graphEvent);
}
