#include "RuleAttributesWidget.h"

#include "ui_RuleAttributesWidget.h"

#include <QStringList>

#include <portgraph/PorgyConstants.h>

#include <tulip/TlpQtTools.h>

using namespace tlp;
using namespace std;

RuleAttributesWidget::RuleAttributesWidget(QWidget *parent):QWidget(parent), _ui(new Ui::RuleAttributes),_g(NULL)
{
    _ui->setupUi(this);
    QString t(LAYOUT_ALGO);
    QStringList tmp = t.split(";");
    _ui->LayoutAlgoCombo->addItems(tmp);

    connect(_ui->LayoutAlgoCombo, SIGNAL(currentIndexChanged (const QString &)), this, SLOT(setAttributes(const QString &)));
}

RuleAttributesWidget::~RuleAttributesWidget() {
    delete _ui;
}

void RuleAttributesWidget::setAttributes(const QString &text) {
    _g->setAttribute(PorgyConstants::LAYOUTALGORITHM, tlp::QStringToTlpString(text));
}

void RuleAttributesWidget::setRuleAttributes(Graph *g) {
    string algo;
    _g=g;
    g->getAttribute(PorgyConstants::LAYOUTALGORITHM,algo);
    int index = _ui->LayoutAlgoCombo->findText(tlpStringToQString(algo));
    if(index!=-1)
        _ui->LayoutAlgoCombo->setCurrentIndex(index);
}
