#ifndef ABSTRACTPORTGRAPHVIEW_H
#define ABSTRACTPORTGRAPHVIEW_H

#include <abstractgraphview.h>

#include <tulip/Graph.h>
#include <tulip/GlGraphRenderingParameters.h>

class PortGraph;

namespace tlp {
struct SelectedEntity;
}

/**
 * @brief The AbstractPortGraphView class is an abstract class to handle view displaying port graphs. Contains the code common to Graph and Rule view.
 */
class AbstractPortGraphView : public AbstractPorgyGraphView
{
    Q_OBJECT

public:
    AbstractPortGraphView();
    ~AbstractPortGraphView();

protected:

    void setupWidget();

    /**
     * @brief buildPortGraph constructs the PortGraph object corresponding to the kind of port graph the view contains.
     * @param graph
     * @return
     */
    virtual PortGraph* buildPortGraph(tlp::Graph* graph)const=0;

protected slots:
    void redrawGraph();
    void invertSelection(tlp::SelectedEntity& selectedentity);
    void setNodeLabelVisibility(bool state);
    void setNodeLabelScaled(bool state);
    void showArrows(bool state);
};

#endif // ABSTRACTPORTGRAPHVIEW_H
