/**
 *
 * This file is part of Porgy (https://gforge.inria.fr/projects/porgy/)
 *
 * from LaBRI, University of Bordeaux 1, Inria Bordeaux - Sud Ouest and King's College London
 *
 * Porgy is free software;  you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 *
 * Porgy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this Porgy.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef ANIMATIONCONFIGURATIONWIDGET_H
#define ANIMATIONCONFIGURATIONWIDGET_H

#include <QWidget>

#include "porgysmallmultiplestraceview.h"

namespace Ui {
    class AnimationConfigurationWidget;
}

/**
  * @brief Configuration widget for animation visualization.
  **/
class AnimationConfigurationWidget : public QWidget
{
    Q_OBJECT

public:


    explicit AnimationConfigurationWidget(QWidget *parent = 0);
    ~AnimationConfigurationWidget();
    unsigned int animationDuration()const;
    unsigned int framePerSecond()const{
        return 50;
    }

    /**
     * @brief rulePreviewGeometry returns the size of the rule preview widget.
     * @return
     */
    RulePreviewGeometry rulePreviewGeometry()const;

private:
    Ui::AnimationConfigurationWidget *ui;

signals:    
    void rulePreviewGeometryChanged();
};

#endif // ANIMATIONCONFIGURATIONWIDGET_H
