#include <tulip/ForEach.h>
#include <tulip/BooleanProperty.h>

#include <portgraph/PortNodeBase.h>

template< typename PROPTYPE,typename NODETYPE ,typename EDGETYPE>
void GraphStateManager::setValueForElements(tlp::Graph* graph,tlp::BooleanProperty* elements,const NODETYPE& nodeValue,const EDGETYPE& edgeValue,PROPTYPE* propertyToUpdate,bool treatNodes,bool treatEdges) const{
    if(treatNodes){
        tlp::node n;
        forEach(n,elements->getNodesEqualTo(true,graph)){
            if(PortNodeBase::isCenter(n,graph)){
                propertyToUpdate->setNodeValue(n,nodeValue);
            }
        }
    }
    if(treatEdges){
        tlp::edge e;
        forEach(e,elements->getEdgesEqualTo(true,graph)){
            std::pair<tlp::node, tlp::node> ends = graph->ends(e);
            if(!PortNodeBase::isCenter(ends.first,graph) && !PortNodeBase::isCenter(ends.second,graph)){
                propertyToUpdate->setEdgeValue(e,edgeValue);
            }
        }
    }
}
