#ifndef GLITEMNAVIGATIONINTERACTOR_H
#define GLITEMNAVIGATIONINTERACTOR_H

#include <QObject>

class GlItem;

/**
 * @brief The GlItemNavigationController class control the navigation for a GlItem. Use the MouseInteraction flag to control the navigation inside of the GlItem.
 */
class GlItemNavigationController : public QObject
{
public:
    enum MouseInteraction{Translation=0x1,Rotation=0x2,Zoom=0x4,All_Interaction=0x7};
    Q_DECLARE_FLAGS(MouseInteractions,MouseInteraction)
private:
    int x,y;
    bool inRotation;
    bool inZoom;
    MouseInteractions _interactions;
public:


    GlItemNavigationController(QObject* parent=NULL);
    GlItemNavigationController(MouseInteractions interactions,QObject* parent=NULL);

    MouseInteractions interactions()const{
        return _interactions;
    }

    void setInteractions(MouseInteractions interactions){
        _interactions = interactions;
    }

    void install(GlItem* item);
    bool eventFilter(QObject *, QEvent *);
};

#endif // GLITEMNAVIGATIONINTERACTOR_H
