import QtQuick 1.1

Rectangle {
    id: button
    signal clicked
    property bool enabled:  true
    property bool toggle: false
    property alias source: icon.source
    smooth: true
    opacity: 0.3
    Behavior on opacity { PropertyAnimation { duration: 100 } }


    Image{
        id: icon
        smooth:  true
        anchors.verticalCenter: parent.verticalCenter
        anchors.horizontalCenter: parent.horizontalCenter
        visible: source != ""
        anchors.fill: button
        fillMode: Image.PreserveAspectFit
    }

    MouseArea {
        id: mouseRegion
        anchors.fill: parent
        hoverEnabled: true
        onPressed: button.state = 'Pressed'
        onReleased: button.state = 'Default'
        onClicked: { button.clicked(); }
        onEntered: {
            button.opacity = 0.7
        }
        onExited: {
            button.opacity = 0.3
        }

        enabled: button.enabled
    }

    states:[
        State {
            name: "Pressed"
            when: mouseRegion.pressed == true
            PropertyChanges {
                target: button
                opacity: 0.7
            }
        }
    ]

    transitions: Transition{
        SmoothedAnimation{ duration: 500 }
    }

    Rectangle{
        id: mask
        anchors.fill: mouseRegion
        visible: !button.enabled
        color: "gray"
        opacity: 0.7

    }
}
