import QtQuick 1.1
Row {    
    signal seekBackward
    signal skipBackward
    signal play
    signal pause
    signal stop
    signal skipForward
    signal seekForward



    property int mode : 1 //Paused
    onModeChanged: {
        if(mode == 0){
            remote_row.state = "Playing";
        }else{
            remote_row.state = "Paused";
        }
    }

    id: remote_row

    Button {
        width: parent.width/6
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 0
        anchors.top: parent.top
        anchors.topMargin: 0
        source: "qrc:/traceAnimationView/icons/32/skip-backward.png"
        onClicked: {remote_row.skipBackward();}
    }

    Button {
        width: parent.width/6
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 0
        anchors.top: parent.top
        anchors.topMargin: 0
        source: "qrc:/traceAnimationView/icons/32/seek-backward.png"
        onClicked: {remote_row.seekBackward();}

    }


    Button {
        id : playButton
        width: parent.width/6
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 0
        anchors.top: parent.top
        anchors.topMargin: 0
        onClicked: {
            if(remote_row.mode == 0){
                remote_row.pause();
            }else{
                remote_row.play();
            }
        }
    }

    state: "Paused"

    states:[
        State {
            name: "Paused"
            PropertyChanges {
                target: playButton
                source: "qrc:/traceAnimationView/icons/32/start.png"
            }
        },
        State {
            name: "Playing"
            PropertyChanges {
                target: playButton
                source: "qrc:/traceAnimationView/icons/32/pause.png"
            }
        }
    ]

    Button {
        width: parent.width/6
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 0
        anchors.top: parent.top
        anchors.topMargin: 0
        source: "qrc:/traceAnimationView/icons/32/stop.png"
        onClicked: {remote_row.stop();}
    }

    Button {
        width: parent.width/6
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 0
        anchors.top: parent.top
        anchors.topMargin: 0
        onClicked: {remote_row.seekForward();}
        source: "qrc:/traceAnimationView/icons/32/seek-forward.png"
    }
    Button {
        width: parent.width/6
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 0
        anchors.top: parent.top
        anchors.topMargin: 0
        onClicked: {remote_row.skipForward();}
        source: "qrc:/traceAnimationView/icons/32/skip-forward.png"
    }
}
