#ifndef PLUGINPARAMETERSCONFIGURATIONDIALOG_H
#define PLUGINPARAMETERSCONFIGURATIONDIALOG_H

#include <QDialog>
#include <tulip/WithParameter.h>

namespace Ui {
class PluginParametersConfigurationDialog;
}

namespace tlp{
class Graph;
class ParameterListModel;
}

class PluginParametersConfigurationDialog : public QDialog
{
    Q_OBJECT

    Ui::PluginParametersConfigurationDialog *ui;
    tlp::DataSet* _defalutValues;
    tlp::ParameterDescriptionList _parameters;
    tlp::Graph* _graph;
    tlp::ParameterListModel* _parametersModel;

    
public:
    explicit PluginParametersConfigurationDialog(QWidget *parent = 0);
    ~PluginParametersConfigurationDialog();

    tlp::DataSet values()const;
    void setDefaultValues(const tlp::DataSet& values);

    tlp::ParameterDescriptionList parametersList()const{
        return _parameters;
    }
    void setParametersList(const tlp::ParameterDescriptionList&);

    tlp::Graph* graph()const{
        return _graph;
    }
    void setGraph(tlp::Graph*);

    static tlp::DataSet getParameters(QWidget* parent,const QString& title,const tlp::ParameterDescriptionList& parameters, bool &ok, tlp::DataSet* defaultValues=NULL,tlp::Graph* graph=NULL);
    
private:
    void updateModel();
};

#endif // PLUGINPARAMETERSCONFIGURATIONDIALOG_H
