#ifndef PLUGINSELECTIONWIZARD_H
#define PLUGINSELECTIONWIZARD_H

#include <QWizard>

#include <string>

namespace Ui {
class PluginSelectionWizard;
}

namespace tlp{
    class SimplePluginListModel;
}

class QModelIndex;

/**
 * @brief The PluginSelectionWizard class is a simple dialog to choose a plugin.
 */
class PluginSelectionWizard : public QWizard
{
    Q_OBJECT

    Ui::PluginSelectionWizard *ui;      
    tlp::SimplePluginListModel* _model;

public:
    explicit PluginSelectionWizard(QWidget *parent = 0);
    ~PluginSelectionWizard();


    void setPluginList(const std::list<std::string>& plugins);
    std::list<std::string> pluginList()const;

    std::string selectedPlugin()const;    

private:
    void updateModel();
private slots:
    void doubleClicked(const QModelIndex&);
};

#endif // PLUGINSELECTIONWIZARD_H
