#include <porgy/pluginselectionwizard.h>

#include "ui_pluginselectionwizard.h"

#include <tulip/PluginModel.h>

using namespace tlp;

PluginSelectionWizard::PluginSelectionWizard(QWidget *parent) :
    QWizard(parent),
    ui(new Ui::PluginSelectionWizard),_model(NULL)
{
    ui->setupUi(this);    
    connect(ui->treeView,SIGNAL(doubleClicked(QModelIndex)),SLOT(doubleClicked(QModelIndex)));
}

PluginSelectionWizard::~PluginSelectionWizard()
{
    delete ui;
}

std::list<std::string> PluginSelectionWizard::pluginList()const{
    return _model->plugins().toStdList();
}
void PluginSelectionWizard::setPluginList(const std::list<std::string>& plugins){
    SimplePluginListModel* oldModel = _model;
    _model = new SimplePluginListModel(QList<std::string>::fromStdList(plugins),this);
    ui->treeView->setModel(_model);
    delete oldModel;
}

std::string PluginSelectionWizard::selectedPlugin()const{
    QModelIndexList indexes = ui->treeView->selectionModel()->selectedRows();
    return indexes.empty()?std::string():_model->pluginName(indexes.front());
}

void PluginSelectionWizard::doubleClicked(const QModelIndex& ){
    accept();//Close the wizard
}
