/**
 *
 * This file is part of Porgy (https://gforge.inria.fr/projects/porgy/)
 *
 * from LaBRI, University of Bordeaux 1, Inria Bordeaux - Sud Ouest and King's College London
 *
 * Porgy is free software;  you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 *
 * Porgy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this Porgy.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef _PORTGRAPHMODEL_H
#define _PORTGRAPHMODEL_H

#include <portgraph/PortGraph.h>

class PortGraphModel:public PortGraph {
        void SortPortNodebyPosition(const tlp::BooleanProperty *prop);
        void build_edges_vector(std::vector<tlp::edge> &v, tlp::BooleanProperty *ban=NULL) const;

public:
	PortGraphModel (tlp::Graph *);
        PortGraphModel (const std::set<tlp::node>, tlp::Graph *);
        tlp::BooleanProperty *getSelectionProperty();        
        bool find(tlp::Graph *left, tlp::DataSet *dataset, bool exact, tlp::PluginProgress *pp);
        virtual tlp::Iterator<tlp::edge> *getEdges(tlp::BooleanProperty *ban=NULL);
        unsigned numberOfEdges() const;

        std::list<std::string> layoutPluginsList()const;
};

#endif
